//-----------------------------------------------------
//	Author	:	Adoniseagle
//	Date	:	14/12/2007
//	Contact	:	adoniseagle@hotmail[dot]com
//------------------------------------------------------

// includes, system
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

// includes, project
#include <cutil.h>

// includes, kernels
#include <cppIntegration_kernel.cu>


namespace cuda_lib
{
	//Bind the array with the appropriate texture in the kernel cu file
	//=>float4 image array
	extern "C" void
	cud_BindTextureToArray(cudaArray *a_Data)
	{
		if(a_Data != NULL)
		{
			CUDA_SAFE_CALL( cudaBindTextureToArray(texData, a_Data) );
		}
	}

	extern "C" void
	cud_UnBindTextureToArray()
	{
		CUDA_SAFE_CALL( cudaUnbindTexture(texData) );		
	}

	extern "C" void
	CallKernelFloat(float * data, unsigned int mem_size)
	{
		 // setup execution parameters
		const unsigned int num_threads = mem_size / 4;
		dim3  grid( 1, 1, 1);
		dim3  threads( mem_size, 1, 1);
		const unsigned int mem_size2 = (mem_size*sizeof(float));		
		testPierroKernel<float><<< grid, threads, mem_size2 >>> (data);
	}
};