//-----------------------------------------------------
//	Author	:	Adoniseagle
//	Date	:	14/12/2007
//	Contact	:	adoniseagle@hotmail[dot]com
//------------------------------------------------------

/* Example of integrating CUDA functions into an existing 
 * application / framework.
 * Device code.
 */

#ifndef _CPP_INTEGRATION_KERNEL_H_
#define _CPP_INTEGRATION_KERNEL_H_


//-- Input data texture reference
texture<float4, 2, cudaReadModeElementType> texData;


template<class T>
__global__ void
testPierroKernel( T* d_data) 
{
	//-- Get the location of the texel corresponding the thread ID
    const unsigned int tid = threadIdx.x;
	//-- get the localized XY data :
	T xy_data = d_data[tid];
	//-- Computation
    d_data[tid] = xy_data + 4;
}


#endif // #ifndef _CPP_INTEGRATION_KERNEL_H_
