//-----------------------------------------------------
//	Author	:	Adoniseagle
//	Date	:	14/12/2007
//	Contact	:	adoniseagle@hotmail[dot]com
//------------------------------------------------------

#pragma once

// includes, system
#include <iostream>


namespace cuda_lib
{
	template<typename T>
	class cpu_vector
	{
		typedef unsigned int uint;
		//__device__ __constant__ T test;
		T * m_h_array;	//the host array memory	(in CPU ram) // h like host
		uint m_size;	//the size of the array

	public:
		cpu_vector()		{			
			m_h_array = NULL;	m_size = 0;		
		};
		~cpu_vector()		{			free(m_h_array);	m_size = 0;		}

		void Allocate(uint Size,bool defaultVal=false, T  defaultvalue =T())	//Be carefull give the size without (* Size(T))
		{
			//allocate host array and set with a default value if it's necessary
			if(m_h_array){ 	free(m_h_array);	m_h_array = (T*)malloc(Size* sizeof(T));
			}
			else	m_h_array = (T*)malloc(Size* sizeof(T));
			m_size = Size;
			if(defaultVal)
			{
				for(int i=0;i<m_size;++i)	m_h_array[i]=defaultvalue;
			}
		}

		T * GetHostMemoryPointer() {return m_h_array;}

		uint GetSize()const	{return m_size;}

		//-----------------------------
		//	Access to the array elements
		//	return the X nth element of the Array
		//-----------------------------
		T&		operator [] (long x)		{	return m_h_array[x];};
		const T	operator [] (long x) const	{	return m_h_array[x];};
	};

};
